//////////////////////////////////////////////////
// os2otp.cpp : Main 
//                                  for os2otp.exe
//                       (C) Hige no Shinshi, 1997

#define INCL_DOSMEMMGR
#define INCL_DOSERRORS
#define INCL_WIN
#define INCL_GPI

#include <os2.h>
#include <stdio.h>
#include <string.h>

#include "os2otp.h"
#include "otpdlg2.h"
#include "profile.h"

extern "C" {
#include "sizes.h"

#include "otp.h"
}

HAB    hab = NULL;
HWND   hMainWnd = NULL;
StatusProfile *pStatus = NULL;

//////////////////////////////////////////////////
// main(): main function
//
int main()
{
    // Jyunbi
    hab = WinInitialize(0);
    HMQ hmq = WinCreateMsgQueue(hab, 0);
    
    // Load Profile
    pStatus = new StatusProfile();
    
    // Create Window
    hMainWnd = WinLoadDlg(HWND_DESKTOP,
                          HWND_DESKTOP,
                          WinOTPDlgProc,
                          0L, WINOTPDLG,
                          NULL);
    // Message Loop
    QMSG qmsg;    
    while (WinGetMsg(hab, &qmsg, NULLHANDLE, 0, 0))
        WinDispatchMsg(hab, &qmsg);

    // Ato Shimatsu
    delete pStatus;

    WinDestroyMsgQueue(hmq);
    
    WinTerminate(hab);

    return 0;
}
//////////////////////////////////////////////////
// ComputePassPhrase(): compute one time passphrase
//
PSZ ComputePassPhrase(PSZ szParams, PSZ szPasswd, PSZ szPhrase)
{
    OTPkeycrunchfcn keycrunch_fcn;
    OTPiteratefcn   iterate_fcn;

    PCSZ szAlg = pStatus->QueryHashAlgName();
    keycrunch_fcn = OTP_GetKeyCrunchFcn((char *)szAlg);
    if (!keycrunch_fcn)
        return NULL;
    iterate_fcn = OTP_GetIterateFcn((char *)szAlg);
    if (!iterate_fcn)
        return NULL;

    char seed [dwWordSize], key[dwWordSize];
    int n;
    if (sscanf(szParams, "%d %s", &n, seed) != 2)
        return NULL;

    // Crunch seed and password into starting key
    if (OTP_KeyCrunch(key, seed, szPasswd, keycrunch_fcn) != 0)
        return NULL;

    while (n-- != 0)
        OTP_IterateHash(key, iterate_fcn);

    if (pStatus->QueryDispWord())
        OTP_btoe(szPhrase, key);
    else
        OTP_put8(szPhrase, key);        

    return szPhrase;
}

//////////////////////////////////////////////////
// CopyPassphraseToClipBoard():
//               copy passphrase to clipboard
//
int CopyPassphraseToClipBoard(PSZ pass)
{
    PSZ sptr;
    const char *szTerm = pStatus->QueryAppendStrStr();
    UINT dwSize = (UINT)strlen(pass)+strlen(szTerm)+1;

    APIRET rc = DosAllocSharedMem((PPVOID)&sptr, NULL, dwSize,
                                  PAG_COMMIT | PAG_READ |
                                  PAG_WRITE | OBJ_TILE | OBJ_GIVEABLE);
    if (rc != NO_ERROR)
        return 0;

    sprintf(sptr, "%s%s", pass, szTerm);

    WinOpenClipbrd(hab);
    WinEmptyClipbrd(hab);
    WinSetClipbrdData(hab, (ULONG)sptr, CF_TEXT, CFI_POINTER);
    WinCloseClipbrd(hab);

    return 1;
}

//////////////////////////////////////////////////
// GetClipboardContents():
//               query clipboard contents
//
UINT GetClipboardContents(PSZ szRecv, UINT nSize)
{
    PCH cptr;
    
    if (!WinOpenClipbrd(hab))
        return 0;
    if (!(cptr = (PCH)WinQueryClipbrdData(hab, CF_TEXT)))
        return 0;

    strncpy(szRecv, cptr, nSize-1);
    if (strlen(cptr) >= nSize-1)
        szRecv[nSize-1] = '\0';
    
    WinCloseClipbrd(hab);

    return (UINT)strlen(szRecv);
}
