//////////////////////////////////////////////////
// otpdlg2.cpp : dialog procedures
//                                  for os2otp.exe
//                       (C) Hige no Shinshi, 1997

#define INCL_WIN
#define INCL_GPI

#include <os2.h>
#include <stdio.h>
#include <string.h>
#include <alloca.h>

#include "os2otp.h"
#include "otpdlg2.h"
#include "profile.h"

//////////////////////////////////////////////////
// DecrementCount(): decrement count
// 
static void DecrementCount (HWND hwnd)
{
    HWND hEditWnd;
    char params [128];
    unsigned int count;
    PSZ seed = (PSZ)alloca(sizeof (CHAR)*128);

    hEditWnd = WinWindowFromID (hwnd, ID_PARAMS);
    WinQueryWindowText (hEditWnd, sizeof (params) - 1, params);
    if ((sscanf (params, "%u %s", &count, seed) != 2) || count <= 1) {
        return;
    }
    sprintf (params, "%u %s", count - 1, seed);
    WinSetWindowText (hEditWnd, params);
}

//////////////////////////////////////////////////
// AboutDlgProc(): about dialog's procedure 
//
MRESULT EXPENTRY AboutDlgProc (HWND hDlg, ULONG msg, MPARAM mp1, MPARAM mp2)
{
    switch (msg)
    {
    case WM_INITDLG:
        return MRFROMSHORT(1);

    case WM_COMMAND:
        switch (COMMANDMSG(&msg)->cmd) {
        case DID_OK:
            WinDismissDlg(hDlg, TRUE);
            return 0;
        }
        break;
    }
    return WinDefDlgProc(hDlg, msg, mp1, mp2);
}
//////////////////////////////////////////////////
// SetWindowTitle(): set main window's title
//
void SetWindowTitle()
{
    PSZ wintitle = (PSZ)alloca(sizeof(CHAR)*64);
    sprintf(wintitle, "OTP One-Time Passphrase Generator [%s]",
            pStatus->QueryHashAlgName());
    WinSetWindowText(hMainWnd, wintitle);
}

//////////////////////////////////////////////////
// WinOTPDlgProc(): main dialog's procedure
//
MRESULT EXPENTRY WinOTPDlgProc (HWND hDlg, ULONG msg, MPARAM mp1, MPARAM mp2)
{
    switch (msg)
    {
    case WM_INITDLG: {
        POINTL pt = pStatus->QueryPoint();
        WinSetWindowPos(hDlg, HWND_TOP, pt.x, pt.y, 0, 0, SWP_MOVE);
        switch (pStatus->QueryHashAlg()){
        case MD4:
            WinCheckButton(hDlg, ID_MD4, TRUE);
            break;
        case MD5:
            WinCheckButton(hDlg, ID_MD5, TRUE);
            break;
        case SHA1:
            WinCheckButton(hDlg, ID_SHA1, TRUE);
            break;
        default:
            WinCheckButton(hDlg, ID_MD4, TRUE);
            break;
        }
        switch (pStatus->QueryAppendStr()) {
        case CR:
            WinCheckButton(hDlg, ID_CLIPADDCR, TRUE);
            break;
        case LF:
            WinCheckButton(hDlg, ID_CLIPADDLF, TRUE);
            break;
        case NULL:
            WinCheckButton(hDlg, ID_CLIPADDNONE, TRUE);
            break;
        default:
            WinCheckButton(hDlg, ID_CLIPADDNONE, TRUE);
            break;
        }
        // Word or HEX
        if (pStatus->QueryDispWord()){
            WinCheckButton(hDlg, ID_DISPWORDS, TRUE);
        } else {
            WinCheckButton(hDlg, ID_DISPHEX, TRUE);
        }
        // Auto Decrement
        if (pStatus->QueryAutoDecrement()) {
            WinCheckButton(hDlg, ID_AUTODECREMENT, TRUE);
        }
        // Params 
        if (pStatus->QueryParams()[0] != NULL) 
            WinSetDlgItemText(hDlg, ID_PARAMS, pStatus->QueryParams());
        return 0;
    } // End of WM_INITDLG
    case WM_CLOSE: {
        SWP swp;
        WinQueryWindowPos(hDlg, &swp);
        pStatus->SetPoint(swp.x, swp.y);
        // 
        PSZ szParams = (PSZ)alloca(sizeof (CHAR)*dwWordSize);
        WinQueryDlgItemText(hDlg, ID_PARAMS, dwWordSize, szParams);
        pStatus->SetParams(szParams);

        WinPostMsg(hDlg, WM_QUIT, NULL, NULL);
        break;
    } // End of WM_CLOSE
    case WM_COMMAND: {
        switch (COMMANDMSG(&msg)->cmd) {
        case ID_EXIT:
        case DID_CANCEL: {
            WinPostMsg(hDlg, WM_CLOSE, NULL, NULL);
            return 0;
        }
        case ID_COMPUTE: {
            PSZ sParams = (PSZ)alloca(sizeof (CHAR)*dwWordSize);
            WinQueryDlgItemText(hDlg, ID_PARAMS, dwWordSize, sParams);

            PSZ sPasswd = (PSZ)alloca(sizeof (CHAR)*dwWordSize);
            WinQueryDlgItemText (hDlg, ID_SECRET, dwWordSize, sPasswd);
            // Empty Password Entry
            WinSetDlgItemText (hDlg, ID_SECRET, (PSZ)"");
            
            PSZ szPhrase = (PSZ)alloca(sizeof (CHAR)*dwPhraseSize);
            if (ComputePassPhrase(sParams, sPasswd, szPhrase)) {
                WinSetDlgItemText(hDlg, ID_PHRASE, szPhrase);
                if (pStatus->QueryAutoDecrement())
                    DecrementCount(hDlg);
            }
            return 0;
        }
        case ID_CLIPBOARD: {
            PSZ szPhrase = (PSZ)alloca(sizeof (CHAR)*dwPhraseSize);
            WinQueryDlgItemText(hDlg, ID_PHRASE, dwWordSize, szPhrase);
            CopyPassphraseToClipBoard (szPhrase);
            return 0;
        }      
        case ID_GETCLIPBOARD: {
            PSZ szRecv = (PSZ)alloca (sizeof (CHAR)*dwWordSize);
            if (!GetClipboardContents(szRecv, 128))
                return 0;
            WinSetDlgItemText(hDlg, ID_PARAMS, szRecv);
            return 0;
        }
        case ID_INFO: {
            WinDlgBox(HWND_DESKTOP, hDlg, AboutDlgProc,
                       NULLHANDLE, ABOUTDLG, NULL);
            return 0;
        }
        case ID_DECREMENT: {
            DecrementCount(hDlg);
            return 0;
        }
        }
        break;
    }// End of WM_COMMAND

    case WM_CONTROL:{
        switch (SHORT1FROMMP(mp1)) {
        case ID_DISPWORDS:{
            pStatus->SetDispWord(TRUE);
            return 0;
        }
        case ID_DISPHEX:{
            pStatus->SetDispWord(FALSE);
            return 0;
        }
        case ID_MD4: {
            pStatus->SetHashAlg(MD4);
            SetWindowTitle();
            return 0;
        }
        case ID_MD5: {
            pStatus->SetHashAlg(MD5);
            SetWindowTitle();
            return 0;
        }
        case ID_SHA1: {
            pStatus->SetHashAlg(SHA1);
            SetWindowTitle();
            return 0;
        }
        case ID_CLIPADDNONE: {
            pStatus->SetAppendStr(NULL);
            return 0;
        }
        case ID_CLIPADDCR: {
            pStatus->SetAppendStr(CR);
            return 0;
        }
        case ID_CLIPADDLF:{
            pStatus->SetAppendStr(LF);
            return 0;
        }
        case ID_AUTODECREMENT: {
            pStatus->SetAutoDecrement(
            (BOOL)WinSendDlgItemMsg(hDlg,
                                    ID_AUTODECREMENT,
                                    BM_QUERYCHECK, 0, 0L));
            return 0;
        }
        } // end of WM_CONTROL
        break;
    }
    }// end msg
	return WinDefDlgProc(hDlg, msg, mp1, mp2);
}
