//////////////////////////////////////////////////
// profile.h: StatusProfile Class's Definition
//                                  for os2otp.exe
//                       (c) Hige no Shinshi, 1997

const UINT MD4  = 0;
const UINT MD5  = 1;
const UINT SHA1 = 2;

const UINT CR   = 1;
const UINT LF   = 2;

//////////////////////////////////////////////////
// StatusProfile: is stored with settings
//
class StatusProfile
{
private: // Data
    UINT m_nHashAlg;
    UINT m_nAppendStr;
    BOOL m_bDispWord;
    BOOL m_bAutoDecrement;
    PSZ m_szParams;
    POINTL m_pt;
public:
    void LoadProfile();
    void SaveProfile();
  
public: // Set Profiles
    void SetHashAlg(UINT nHashAlg) { m_nHashAlg = nHashAlg; }
    void SetAppendStr(UINT nAppendStr) { m_nAppendStr = nAppendStr; }
    void SetDispWord(BOOL bDispWord) { m_bDispWord = bDispWord; }
    void SetAutoDecrement(BOOL bAutoDecrement) { m_bAutoDecrement = bAutoDecrement; }
    void SetPoint(POINTL pt) { m_pt = pt; }
    void SetPoint(LONG x, LONG y) {m_pt.x = x; m_pt.y = y; }
    void SetParams(PSZ szParams);
    
public: // Query Profiles
    UINT QueryHashAlg() const { return m_nHashAlg; }
    PCSZ QueryHashAlgName();
    UINT QueryAppendStr() const { return m_nAppendStr; }
    PCSZ QueryAppendStrStr();
    BOOL QueryDispWord() const { return m_bDispWord; }
    BOOL QueryAutoDecrement() const { return m_bAutoDecrement; }
    POINTL QueryPoint() const { return m_pt; }
    PSZ QueryParams() const { return m_szParams; }
    
public: // Constructor / Destructor
    StatusProfile();
    virtual ~StatusProfile();
};

extern StatusProfile *pStatus;
